package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.CompanyInfoDetail;
import com.izouma.awesomeadmin.service.CompanyInfoDetailService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/companyInfoDetail")
public class CompanyInfoDetailController {

    @Autowired
    private CompanyInfoDetailService companyInfoDetailService;

    /**
    * <p>获取全部记录。</p>
    */
//    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(CompanyInfoDetail record) {
        List<CompanyInfoDetail> pp = companyInfoDetailService.getCompanyInfoDetailList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getCompanyInfoDetail", method = RequestMethod.GET)
    @ResponseBody
    public Result getCompanyInfoDetail(@RequestParam(required = false, value = "id") String id) {
        CompanyInfoDetail data = companyInfoDetailService.getCompanyInfoDetailById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(CompanyInfoDetail record) {
        CompanyInfoDetail data = companyInfoDetailService.getCompanyInfoDetail(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, CompanyInfoDetail record) {
        Map<String, Object> result = new HashMap<>();

        List<CompanyInfoDetail> pp =companyInfoDetailService.getCompanyInfoDetailByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(CompanyInfoDetail record) {
        boolean num = companyInfoDetailService.createCompanyInfoDetail(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateCompanyInfoDetail(CompanyInfoDetail record) {
        boolean num = companyInfoDetailService.updateCompanyInfoDetail(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value= "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteCompanyInfoDetail(CompanyInfoDetail record) {

        boolean num = companyInfoDetailService.deleteCompanyInfoDetail(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, CompanyInfoDetail record) throws Exception {

    List<CompanyInfoDetail> companyInfoDetails = companyInfoDetailService.getCompanyInfoDetailList(record);


        String sheetName = "company_info_detail";
        String titleName = "世界智能制造大会参展企业明细表数据表";
        String fileName = "世界智能制造大会参展企业明细表表";
        int columnNumber = 12;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "企业名称" ,   "展馆" ,   "展位号" ,   "公司介绍" ,   "语音介绍" ,   "排序"  };
        String[][] dataList = new String[companyInfoDetails.size()][12];

        for (int i = 0; i < companyInfoDetails.size(); i++) {

                        dataList[i][0] = String.valueOf(companyInfoDetails.get(i).getId());
                        dataList[i][1] = String.valueOf(companyInfoDetails.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(companyInfoDetails.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(companyInfoDetails.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(companyInfoDetails.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(companyInfoDetails.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(companyInfoDetails.get(i).getCompanyName());
                        dataList[i][7] = String.valueOf(companyInfoDetails.get(i).getHall());
                        dataList[i][8] = String.valueOf(companyInfoDetails.get(i).getBoothNo());
                        dataList[i][9] = String.valueOf(companyInfoDetails.get(i).getIntroduce());
                        dataList[i][10] = String.valueOf(companyInfoDetails.get(i).getVoice());
                        dataList[i][11] = String.valueOf(companyInfoDetails.get(i).getRank());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

